package com.fp.persistence.parmas.eval;

import javax.persistence.Entity;

import java.sql.Timestamp;

import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import java.lang.reflect.Field;

import javax.persistence.Transient;

import java.sql.Date;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMEVALUACION*/
@Entity(name="TarmEvaluacion")
@Table(name="TARMEVALUACION")
public class TarmEvaluacion extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmEvaluacion
*/
@Id
@Column(name="CEVALUACION" ,nullable=false, updatable=false)
private String pk;
@Column(name="TIPOEVALUACION", nullable=true)

/**
* Codigo de catalogo  01 Conocimiento Guardias, 02 Conocimiento Particulares
*/
private String tipoevaluacion;

@Column(name="FECHA", nullable=true)

/**
* Fecha en la que se rindio la evaluación
*/
private Timestamp fecha;

@Column(name="INTENTO", nullable=true)

/**
* # de Intento en la evaluación
*/
private Long intento;

@Column(name="CENTROMEDICO", nullable=true)

/**
* null
*/
private String centromedico;

@Column(name="VIGENTE", nullable=true)

/**
* null
*/
private String vigente;

@Column(name="FECHADEPOSITO", nullable=true)

/**
* null
*/
private Date fechadeposito;

@Column(name="NOPAPELETA", nullable=true)

/**
* null
*/
private String nopapeleta;

@Column(name="PERSONCODE", nullable=true)

/**
* Codigo de persona a ser evaluada
*/
private Integer personcode;

@Column(name="TIPOEVALUACIONCODIGO", nullable=true)

/**
* Codigo de tabla de catalogo 01 Codigo de tabla de tipos de evaluación
*/
private String tipoevaluacioncodigo;

@Column(name="FECHAEXPIRACION", nullable=true)

/**
* FECHA DE EXPIRACON DE LA EVALUACION
*/
private Date fechaexpiracion;

@Column(name="FREGISTRO", nullable=true)

/**
* null
*/
private Timestamp fregistro;

@Column(name="RESULTADOCODIGO", nullable=true)

/**
* Codigo de tabla de catalogo 01 Codigo de tabla de tipos de resultado

*/
private String resultadocodigo;

@Column(name="PSICOLOGORESPONSABLE", nullable=true)

/**
* NOMBRE DEL DOCTOR PSICOLOGO RESPONSABLE DE LA EVALUACION PSICOLOGICA
*/
private String psicologoresponsable;

@Column(name="OBSERVACION", nullable=true)

/**
* OBSERVACIONES DENTRO DE LA EVALUACION PSICOLOGICA
*/
private String observacion;

@Column(name="FECHAPREOX", nullable=true)

/**
* Fecha en la cual puede volver a rendir la evalaucion
*/
private Date fechapreox;

@Column(name="INFORMEXPATH", nullable=true)

/**
* PATH DONDE SE ALMACENA LA INFORMACION DE LA EVALUACION PSICOLOGICA
*/
private String informexpath;

@Column(name="RESULTADO", nullable=true)

/**
* Codigo de catalogo  01 Aprobado, 02 Reprobado
*/
private String resultado;

@Column(name="CENTROMEDICOCODE", nullable=true)

/**
* null
*/
private String centromedicocode;

@Column(name="EMPRESAPERSONCODE", nullable=true)

/**
* null
*/
private Integer empresapersoncode;

@Column(name="TIPDOCPSICOLOGO", nullable=true)

/**
* null
*/
private String tipdocpsicologo;

@Column(name="TIPDOCCODEPSICOLOGO", nullable=true)

/**
* null
*/
private String tipdoccodepsicologo;

@Column(name="NUMDOCPSICOLOGO", nullable=true)

/**
* null
*/
private String numdocpsicologo;

/**Contructor por defecto*/
public TarmEvaluacion(){
}
/**Contructor de TarmEvaluacion
@param pPk Clave Primaria del entity
*/
public TarmEvaluacion(String pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmEvaluacion
*/
public static TarmEvaluacion find(EntityManager pEntityManager,Object pKey) throws Exception{
    TarmEvaluacion obj = pEntityManager.find(TarmEvaluacion.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmEvaluacion
@return El objeto que referencia a la Clave primaria de TarmEvaluacion
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmEvaluacion
@param pPk El objeto que referencia a la nueva Clave primaria de TarmEvaluacion
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de tipoevaluacion
@return valor de tipoevaluacion*/
public String getTipoevaluacion(){
  return tipoevaluacion;
}
/**Fija el valor de tipoevaluacion
@param pTipoevaluacion nuevo Valor de tipoevaluacion*/
public void setTipoevaluacion(String pTipoevaluacion){
  tipoevaluacion=pTipoevaluacion;
}

/**Obtiene el valor de fecha
@return valor de fecha*/
public Timestamp getFecha(){
  return fecha;
}
/**Fija el valor de fecha
@param pFecha nuevo Valor de fecha*/
public void setFecha(Timestamp pFecha){
  fecha=pFecha;
}

/**Obtiene el valor de intento
@return valor de intento*/
public Long getIntento(){
  return intento;
}
/**Fija el valor de intento
@param pIntento nuevo Valor de intento*/
public void setIntento(Long pIntento){
  intento=pIntento;
}

/**Obtiene el valor de centromedico
@return valor de centromedico*/
public String getCentromedico(){
  return centromedico;
}
/**Fija el valor de centromedico
@param pCentromedico nuevo Valor de centromedico*/
public void setCentromedico(String pCentromedico){
  centromedico=pCentromedico;
}

/**Obtiene el valor de vigente
@return valor de vigente*/
public String getVigente(){
  return vigente;
}
/**Fija el valor de vigente
@param pVigente nuevo Valor de vigente*/
public void setVigente(String pVigente){
  vigente=pVigente;
}

/**Obtiene el valor de fechadeposito
@return valor de fechadeposito*/
public Date getFechadeposito(){
  return fechadeposito;
}
/**Fija el valor de fechadeposito
@param pFechadeposito nuevo Valor de fechadeposito*/
public void setFechadeposito(Date pFechadeposito){
  fechadeposito=pFechadeposito;
}

/**Obtiene el valor de nopapeleta
@return valor de nopapeleta*/
public String getNopapeleta(){
  return nopapeleta;
}
/**Fija el valor de nopapeleta
@param pNopapeleta nuevo Valor de nopapeleta*/
public void setNopapeleta(String pNopapeleta){
  nopapeleta=pNopapeleta;
}

/**Obtiene el valor de personcode
@return valor de personcode*/
public Integer getPersoncode(){
  return personcode;
}
/**Fija el valor de personcode
@param pPersoncode nuevo Valor de personcode*/
public void setPersoncode(Integer pPersoncode){
  personcode=pPersoncode;
}

/**Obtiene el valor de tipoevaluacioncodigo
@return valor de tipoevaluacioncodigo*/
public String getTipoevaluacioncodigo(){
  return tipoevaluacioncodigo;
}
/**Fija el valor de tipoevaluacioncodigo
@param pTipoevaluacioncodigo nuevo Valor de tipoevaluacioncodigo*/
public void setTipoevaluacioncodigo(String pTipoevaluacioncodigo){
  tipoevaluacioncodigo=pTipoevaluacioncodigo;
}

/**Obtiene el valor de fechaexpiracion
@return valor de fechaexpiracion*/
public Date getFechaexpiracion(){
  return fechaexpiracion;
}
/**Fija el valor de fechaexpiracion
@param pFechaexpiracion nuevo Valor de fechaexpiracion*/
public void setFechaexpiracion(Date pFechaexpiracion){
  fechaexpiracion=pFechaexpiracion;
}

/**Obtiene el valor de fregistro
@return valor de fregistro*/
public Timestamp getFregistro(){
  return fregistro;
}
/**Fija el valor de fregistro
@param pFregistro nuevo Valor de fregistro*/
public void setFregistro(Timestamp pFregistro){
  fregistro=pFregistro;
}

/**Obtiene el valor de resultadocodigo
@return valor de resultadocodigo*/
public String getResultadocodigo(){
  return resultadocodigo;
}
/**Fija el valor de resultadocodigo
@param pResultadocodigo nuevo Valor de resultadocodigo*/
public void setResultadocodigo(String pResultadocodigo){
  resultadocodigo=pResultadocodigo;
}

/**Obtiene el valor de psicologoresponsable
@return valor de psicologoresponsable*/
public String getPsicologoresponsable(){
  return psicologoresponsable;
}
/**Fija el valor de psicologoresponsable
@param pPsicologoresponsable nuevo Valor de psicologoresponsable*/
public void setPsicologoresponsable(String pPsicologoresponsable){
  psicologoresponsable=pPsicologoresponsable;
}

/**Obtiene el valor de observacion
@return valor de observacion*/
public String getObservacion(){
  return observacion;
}
/**Fija el valor de observacion
@param pObservacion nuevo Valor de observacion*/
public void setObservacion(String pObservacion){
  observacion=pObservacion;
}

/**Obtiene el valor de fechapreox
@return valor de fechapreox*/
public Date getFechapreox(){
  return fechapreox;
}
/**Fija el valor de fechapreox
@param pFechapreox nuevo Valor de fechapreox*/
public void setFechapreox(Date pFechapreox){
  fechapreox=pFechapreox;
}

/**Obtiene el valor de informexpath
@return valor de informexpath*/
public String getInformexpath(){
  return informexpath;
}
/**Fija el valor de informexpath
@param pInformexpath nuevo Valor de informexpath*/
public void setInformexpath(String pInformexpath){
  informexpath=pInformexpath;
}

/**Obtiene el valor de resultado
@return valor de resultado*/
public String getResultado(){
  return resultado;
}
/**Fija el valor de resultado
@param pResultado nuevo Valor de resultado*/
public void setResultado(String pResultado){
  resultado=pResultado;
}

/**Obtiene el valor de centromedicocode
@return valor de centromedicocode*/
public String getCentromedicocode(){
  return centromedicocode;
}
/**Fija el valor de centromedicocode
@param pCentromedicocode nuevo Valor de centromedicocode*/
public void setCentromedicocode(String pCentromedicocode){
  centromedicocode=pCentromedicocode;
}

/**Obtiene el valor de empresapersoncode
@return valor de empresapersoncode*/
public Integer getEmpresapersoncode(){
  return empresapersoncode;
}
/**Fija el valor de empresapersoncode
@param pEmpresapersoncode nuevo Valor de empresapersoncode*/
public void setEmpresapersoncode(Integer pEmpresapersoncode){
  empresapersoncode=pEmpresapersoncode;
}

public String getTipdocpsicologo() {
	return tipdocpsicologo;
}
public void setTipdocpsicologo(String tipdocpsicologo) {
	this.tipdocpsicologo = tipdocpsicologo;
}
public String getTipdoccodepsicologo() {
	return tipdoccodepsicologo;
}
public void setTipdoccodepsicologo(String tipdoccodepsicologo) {
	this.tipdoccodepsicologo = tipdoccodepsicologo;
}
public String getNumdocpsicologo() {
	return numdocpsicologo;
}
public void setNumdocpsicologo(String numdocpsicologo) {
	this.numdocpsicologo = numdocpsicologo;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmEvaluacion))return false;
    TarmEvaluacion that = (TarmEvaluacion) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmEvaluacion
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmEvaluacion
*/
public Object createInstance(){
 TarmEvaluacion instance=new TarmEvaluacion();	
 return instance;
}
/**Clona la entidad TarmEvaluacion
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmEvaluacion p=(TarmEvaluacion)this.clone();
  return p;
}
}
